SETNAM	= $FFBD
SETLFS	= $FFBA
OPEN	= $FFC0
CHKOUT	= $FFC9
CHROUT	= $FFD2
CLOSE	= $FFC3
CLRCHN	= $FFCC
STROUT	= $CB1E

VIC	= $9000

SCR	= 87
BTM	= 89
COL	= 91
BADR	= 93
CADR	= 95
TADR	= 172
BPTR1	= 174
BPTR2	= 176
TEMP	= 178
N1	= 700
N2	= 702
RES	= 703
REM	= 704

	*= $A100

BEGIN	LDA #0			; set name length
	JSR SETNAM		; set file name
	LDA #4			; set LFN
	TAX			; set device
	LDY #255		; no secondary address
	JSR SETLFS		; set logical, device, SA
	JSR OPEN		; open LFN
	LDX #4			; set LFN
	JSR CHKOUT		; set output device
	LDA #8			; enter graphics mode
	JSR CHROUT		; send character to printer
	LDY #0			; clear .Y
	STY SCR			; set screen address low byte
	LDA VIC+5		; get video and character memory addresses
	AND #%01110000		; mask video memory address b13-10
	LSR
	LSR
	STA SCR+1		; set screen address high byte
	LDA VIC+2		; get video address and screen columns
	AND #%10000000		; mask video memory address b9
	JSR D64			; divide by 64
	ORA SCR+1		; OR into high bits
	STA SCR+1		; set screen address high byte
	STY BTM			; set bitmap address low byte
	LDA VIC+5		; get video and character memory addresses
	AND #%00001111		; mask character memory address b13-10
	ASL
	ASL
	STA BTM+1		; set bitmap address high byte
	LDA VIC+2		; get video address and screen columns
	AND #%01111111		; mask number of columns
	STA WTH			; set screen width
	LDA VIC+3		; get screen rows and character height
	AND #%01111110		; mask number of rows
	LSR			; divide by 2
	STA HGT			; set screen height
	LDA VIC+3		; get screen rows and character height
	AND #1			; mask character height
	ASL			; multiply ..
	ASL
	ASL			; .. by 8
	CLC
	ADC #8			; add 8
	STA CHGT		; set character height
	STY COL			; set colour address low byte
	LDA VIC+2		; get video address and screen columns
	AND #%10000000		; mask colour address b9
	JSR D64			; divide by 64
	CLC
	ADC #$94		; add to colour memory base
	STA COL+1		; set colour address high byte
	STY N1+1
	LDA HGT			; get screen height
	STA N1
	LDA CHGT		; get character height
	STA N2
	JSR MULT		; compute height in pixels
	STY TEMP+1
	LDA RES			; get result
	STA PIXH		; set pixel height
	ASL
	STA TEMP
	ROL TEMP+1
	LDA #<480
	SEC
	SBC TEMP
	STA TABP
	LDA #>480
	SBC TEMP+1
	LSR
	STA TABP+1
	ROR TABP
	JSR TAB
	LDA VIC+15		; get background and border colour
	TAX			; save register
	AND #%11110000		; mask background colour
	JSR D16			; divide by 16
	STA CREG		; set background colour
	TXA			; restore register
	AND #%00000111		; mask border colour
	STA CREG+1		; set border colour
	LDA VIC+14		; get auxiliary colour and volume
	AND #%11110000		; mask auxiliary colour
	JSR D16			; divide by 16
	STA CREG+3		; set auxiliary colour
	LDY #0			; clear .Y
	TXA			; restore register
	AND #8			; mask reverse video bit
	BNE NVID		; branch if normal video
	DEY			; set .Y to $FF
NVID	STY RVID		; set reverse bitmask
	LDY #0
	STY COUNT

LOOP1	LDX PIXH		; get pixel height
	DEX
	STX YCO
	LDA #<BUF1
	STA BPTR1
	LDA #>BUF1
	STA BPTR1+1
	LDA #<BUF2
	STA BPTR2
	LDA #>BUF2
	STA BPTR2+1
LOOP2	LDA #128
	LDY #6
CLOOP	DEY
	STA ROW1,Y
	BNE CLOOP

	STY XCO
LOOP3	JSR SHADE
	STA SH
	ASL
	ASL
	ASL
	STA TEMP
	LDA COUNT
	AND #1
	ASL
	ASL
	CLC
	ADC TEMP
	STA TEMP
	LDA YCO
	AND #1
	ASL
	CLC
	ADC TEMP
	TAX
	STX ARRAY
	LDA Z1,X
	STA TEMP
	LDX XCO
	LDA M1,X
	AND TEMP
	ORA ROW1
	STA ROW1
	LDX ARRAY
	INX
	LDA Z1,X
	STA TEMP
	LDX XCO
	LDA M1,X
	AND TEMP
	ORA ROW2
	STA ROW2
	LDX ARRAY
	LDA Z2,X
	STA TEMP
	LDX XCO
	LDA M2,X
	AND TEMP
	ORA ROW1+1
	STA ROW1+1
	LDX ARRAY
	INX
	LDA Z2,X
	STA TEMP
	LDX XCO
	LDA M2,X
	AND TEMP
	ORA ROW2+1
	STA ROW2+1
	LDX ARRAY
	LDA Z3,X
	STA TEMP
	LDX XCO
	LDA M3,X
	AND TEMP
	ORA ROW1+2
	STA ROW1+2
	LDX ARRAY
	INX
	LDA Z3,X
	STA TEMP
	LDX XCO
	LDA M3,X
	AND TEMP
	ORA ROW2+2
	STA ROW2+2
	INC XCO
	LDX XCO
	CPX #7
	BCS OV7
	JMP LOOP3

OV7	LDA ROW1
	JSR CHROUT		; send character to printer
	LDA ROW2
	JSR CHROUT		; send character to printer
	LDY #0
	LDA ROW1+1
	STA (BPTR1),Y	
	LDA ROW1+2
	STA (BPTR2),Y
	INC BPTR1
	INC BPTR2
	BNE IOV
	INC BPTR1+1
	INC BPTR2+1
IOV	LDA ROW2+1
	STA (BPTR1),Y
	LDA ROW2+2
	STA (BPTR2),Y
	INC BPTR1
	INC BPTR2
	BNE IOV2
	INC BPTR1+1
	INC BPTR2+1
IOV2	DEC YCO
	LDA YCO
	CMP #255
	BEQ OV8
	JMP LOOP2

OV8	JSR TAB
	LDA #<BUF1
	STA TEMP
	LDA #>BUF1
	STA TEMP+1
OLOOP	LDY #0
	LDA (TEMP),Y
	JSR CHROUT		; send character to printer
	INC TEMP
	BNE IOV3
	INC TEMP+1
IOV3	LDA TEMP
	CMP BPTR1
	BNE OLOOP
	LDA TEMP+1
	CMP BPTR1+1
	BNE OLOOP

	JSR TAB
	LDA #<BUF2
	STA TEMP
	LDA #>BUF2
	STA TEMP+1
OLOOP2	LDY #0
	LDA (TEMP),Y
	JSR CHROUT		; send character to printer
	INC TEMP
	BNE IOV4
	INC TEMP+1
IOV4	LDA TEMP
	CMP BPTR2
	BNE OLOOP2
	LDA TEMP+1
	CMP BPTR2+1
	BNE OLOOP2

	JSR TAB
	LDA COUNT
	CLC
	ADC #7
	STA COUNT
	LDA WTH
	ASL
	ASL
	ASL
	CMP COUNT
	BCC OV9
	JMP LOOP1

	; dump complete, close printer channel
	
OV9	LDA #15			; enter standard character mode
	JSR CHROUT		; send character to printer
	LDA #4
	JSR CLOSE		; close LFN
	JSR CLRCHN		; reset output channel
	RTS


;***********************************************************************************;
;
; 16 bit integer multiply
;
; multiply N1(16) by N2(8), leave result in RES(16)

MULT	LDA #0
	STA RES
	STA RES+1
	LDX #8
MLOOP	LSR N2
	BCC MOVER
	LDA N1
	CLC
	ADC RES
	STA RES
	LDA N1+1
	ADC RES+1
	STA RES+1
MOVER	ASL N1
	ROL N1+1
	DEX
	BNE MLOOP
	RTS


;***********************************************************************************;
;
; move printhead to TABP

TAB	LDY #>TABD		; get start position command low byte
	LDA #<TABD		; get start position command high byte
	JSR STROUT		; send start position command
	LDA TABP+1		; get dot address high byte
	JSR CHROUT		; send character to printer
	LDA TABP		; get dot address low byte
	JMP CHROUT		; send character to printer


;***********************************************************************************;
;

SHADE	LDA COUNT
	CLC
	ADC XCO
	STA XX
	PHA
	LDA WTH
	ASL
	ASL
	ASL
	STA TEMP
	PLA
	CMP TEMP
	BCC OK
	LDA #0
	RTS

OK	LDA XX
	LSR
	LSR
	LSR
	STA CX
	LDA YCO
	STA N1
	LDA CHGT
	STA N2
	JSR DIV
	LDA RES
	STA CY
	STA N1
	LDY #0
	STY N1+1
	LDA WTH
	STA N2
	JSR MULT
	LDA RES
	CLC
	ADC CX
	BCC OV
	INC RES+1
OV	STA OFF
	LDA RES+1
	STA OFF+1
	LDA SCR
	CLC
	ADC OFF
	STA BADR
	LDA SCR+1
	ADC OFF+1
	STA BADR+1
	LDA COL
	CLC
	ADC OFF
	STA CADR
	LDA COL+1
	ADC OFF+1
	STA CADR+1
	LDA (CADR),Y
	PHA			; save colour attribute
	AND #7			; mask foreground colour
	STA CREG+2		; set foreground colour
	STY N1+1
	LDA (BADR),Y
	STA N1
	LDA CHGT
	STA N2
	JSR MULT
	LDA RES
	CLC
	ADC BTM
	STA TADR
	LDA RES+1
	ADC BTM+1
	AND #$3F		; VIC has 14-bit address bus
	TAX			; save bitmap address high byte
	AND #$20		; test b13
	BNE BMLOW		; branch if set
	TXA			; restore bitmap address high byte
	ORA #$80		; address is in character ROM
	BNE BMSET		; branch always

BMLOW	TXA			; restore bitmap address high byte
	AND #$DF		; mask off b13
BMSET	STA TADR+1		; set bitmap address high byte

	LDX CHGT
	DEX
	TXA
	AND YCO
	CLC
	ADC TADR
	STA TADR
	BCC OV3
	INC TADR+1
OV3	LDA (TADR),Y
	STA BTV
	PLA			; restore colour attribute
	AND #8			; mask multicolour bit
	BNE MTCL		; branch if multicolour

	LDA BTV			; get byte value
	EOR RVID		; XOR with reverse bitmap
	STA BTV			; set byte value
	LDA XX
	AND #7
	TAX
	LDA HDATA,X		; get bitmask for bit position
	AND BTV			; AND with byte value
	BEQ BGD
	LDX #2			; set foreground colour
	BNE ESH

BGD	LDX #0			; set background colour
	BEQ ESH

	; colour attribute has multicolour bit set

MTCL	LDA BTV
	STA N1
	LDA XX
	AND #7
	TAX
	LDA MDATA,X		; get divisor for bit position
	STA N2
	JSR DIV			; shift byte value down
	LDA RES			; get pixel value
	AND #3
	TAX
ESH	LDA CREG,X		; look up colour in colour register
	TAX
	LDA SHAD,X		; look up shade in shade map
	RTS


;***********************************************************************************;
;
; 8 bit integer divide
;
; divide N1 by N2, leave result in RES & REM

DIV	LDA #0
	STA RES
	STA REM
	LDX #8
DLOOP	ASL N1
	ROL REM
	LDA REM
	SEC
	SBC N2
	PHP
	ROL RES
	PLP
	BMI DOVER
	STA REM
DOVER	DEX
	BNE DLOOP
	RTS


;***********************************************************************************;
;
; simple 8 bit multiplication

M64	ASL			; multiply by 64
M32	ASL			; multiply by 32
M16	ASL			; multiply by 16
	ASL
	ASL
	ASL
	RTS


;***********************************************************************************;
;
; simple 8 bit division

D64	LSR			; divide by 64
D32	LSR			; divide by 32
D16	LSR			; divide by 16
	LSR
	LSR
	LSR
	RTS

HDATA	.BYT 128,64,32,16,8,4,2,1
MDATA	.BYT 64,64,16,16,4,4,1,1
SHAD	.BYT 4,0,3,2,3,2,3,1,3
	.BYT 2,2,1,2,1,2,1

TABD	.BYT 13,27,16,0		; CR, start pos, dot address

M1	.BYT 135,184,192,128,128,128,128
M2	.BYT 128,128,131,156,224,128,128
M3	.BYT 128,128,128,128,129,142,240

Z1	.BYT 128,128,128,128,128,128,128,128
	.BYT 146,128,164,128,146,128,164,128
	.BYT 140,225,225,140,225,140,140,225
	.BYT 213,170,213,170,170,213,170,213
	.BYT 255,255,255,255,255,255,255,255
Z2	.BYT 128,128,128,128,128,128,128,128
	.BYT 201,128,146,128,201,128,146,128
	.BYT 134,176,176,134,176,134,134,176
	.BYT 170,213,170,213,213,170,213,170
	.BYT 255,255,255,255,255,255,255,255
Z3	.BYT 128,128,128,128,128,128,128,128
	.BYT 164,128,201,128,164,128,201,128
	.BYT 195,152,152,195,152,195,195,152
	.BYT 213,170,213,170,170,213,170,213
	.BYT 255,255,255,255,255,255,255,255

HGT	= *
WTH	= *+1
CHGT	= *+2
PIXH	= *+3
TABP	= *+4
CREG	= *+6
COUNT	= *+10
XCO	= *+11
YCO	= *+12
ROW1	= *+13
ROW2	= *+16
XX	= *+19
CX	= *+20
CY	= *+21
OFF	= *+22
BTV	= *+24
SH	= *+25
ARRAY	= *+26
RVID	= *+27

BUF1	= *+33
BUF2	= *+545

	.END
